'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _yylibUi = require('yylib-ui');

var _ajax = require('yylib-utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * ncc附件上传组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xg
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var confirm = _yylibUi.YYModal.confirm;

var NccAttachUpload = function (_React$Component) {
    _inherits(NccAttachUpload, _React$Component);

    function NccAttachUpload(props) {
        _classCallCheck(this, NccAttachUpload);

        var _this2 = _possibleConstructorReturn(this, (NccAttachUpload.__proto__ || Object.getPrototypeOf(NccAttachUpload)).call(this, props));

        _this2.loadFiles = function () {
            var _this2$state = _this2.state,
                appCode = _this2$state.appCode,
                billId = _this2$state.billId;
            var _this2$props = _this2.props,
                serverUrl = _this2$props.serverUrl,
                queryUrl = _this2$props.queryUrl;

            if (appCode && billId) {
                var params = {
                    busiParamJson: JSON.stringify({
                        billId: '' + (appCode + '/' + billId),
                        fullPath: '' + (appCode + '/' + billId)
                    }),
                    sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
                };
                _ajax2.default.postJSONWithCookies(serverUrl + queryUrl, params, function (result) {
                    if (result && result.success) {
                        var data = result.data || [];
                        var fileList = [];
                        data.map(function (file) {
                            fileList.push({
                                uid: file.pk_doc,
                                name: file.name,
                                url: "http://www.baidu.com",
                                status: 'done',
                                response: { data: [file], success: true }
                            });
                        });
                        _this2.setState({ files: fileList });
                    }
                });
            }
        };

        _this2.beforeUpload = function (file) {
            var retFlag = true;
            var _this2$props2 = _this2.props,
                accept = _this2$props2.accept,
                beforeUpload = _this2$props2.beforeUpload,
                serverUrl = _this2$props2.serverUrl,
                uploadUrl = _this2$props2.uploadUrl;
            // 1.校验附件服务基准地址和上传附件的服务地址

            if (!serverUrl || !uploadUrl) {
                _yylibUi.YYMessage.error("附件服务地址未配置,无法上传");
                return false;
            }
            // 2.校验文件大小
            if (file.size === 0) {
                _yylibUi.YYMessage.error("不允许上传空文件");
                return false;
            }
            // 3.校验文件格式
            if (accept) {
                var accpetSuffix = accept.split(",");
                var fileName = file.name;
                var suffix = fileName.substr(fileName.lastIndexOf("."), fileName.length);
                if (accpetSuffix.indexOf(suffix) === -1) {
                    _yylibUi.YYMessage.error("只允许上传" + accept + "格式的文件");
                    return false;
                }
            }
            // 4.回调外部属性
            if (beforeUpload && typeof beforeUpload === "function") {
                retFlag = beforeUpload(file) || false;
            }
            return retFlag;
        };

        _this2.getUploadParams = function () {
            var _this2$state2 = _this2.state,
                appCode = _this2$state2.appCode,
                billId = _this2$state2.billId;

            return {
                billId: '' + (appCode + '/' + billId),
                fullPath: '' + (appCode + '/' + billId),
                sys_appcode: '' + appCode
            };
        };

        _this2.onChange = function (_ref) {
            var file = _ref.file,
                fileList = _ref.fileList;

            if (file && file.status === "done") {
                if (file.response && !file.response.success) {
                    _yylibUi.YYMessage.error(file.response.error && file.response.error.message ? file.response.error.message : "上传失败");
                }
            }
            fileList = fileList.map(function (file) {
                if (file.response) {
                    // 组件会将 file.url 作为链接进行展示
                    file.url = "http://www.baidu.com"; // 暂时不支持在线预览，所以不会用到该url
                }
                return file;
            });
            // 筛选成功上传的文件
            fileList = fileList.filter(function (file) {
                if (file.response) {
                    return file.response.success === true;
                }
                return true;
            });
            _this2.setState({ files: fileList }, _this2.changeValue);
        };

        _this2.onPreview = function (file) {
            var _this2$props3 = _this2.props,
                serverUrl = _this2$props3.serverUrl,
                downloadUrl = _this2$props3.downloadUrl;

            var requestUrl = serverUrl + downloadUrl;
            // 通过内嵌iframe窗口实现下载
            var downloadFrame = document.createElement('iframe');
            downloadFrame.id = "down-file-iframe";
            downloadFrame.style.width = "0";
            downloadFrame.style.height = "0";
            downloadFrame.style.display = "none";
            // 通过form实现post请求
            var downloadForm = document.createElement('form');
            downloadForm.id = "down-file-form";
            downloadForm.target = "down-file-iframe";
            downloadForm.method = "post";
            downloadForm.action = requestUrl;
            downloadForm.style.visibility = "hidden";
            // 通过隐藏的input标签传递参数
            var nameInput = document.createElement('input');
            nameInput.type = 'hidden';
            nameInput.name = "name";
            nameInput.value = file.response.data[0].name;
            var pkDocInput = document.createElement('input');
            pkDocInput.type = 'hidden';
            pkDocInput.name = "pk_doc";
            pkDocInput.value = file.response.data[0].pk_doc;
            downloadForm.append(nameInput);
            downloadForm.append(pkDocInput);
            downloadFrame.append(downloadForm);
            document.body.appendChild(downloadFrame);
            document.getElementById("down-file-form").submit();
            document.body.removeChild(downloadFrame);
        };

        _this2.onRemove = function (file) {
            var _this = _this2;
            var _this2$props4 = _this2.props,
                deleteTip = _this2$props4.deleteTip,
                serverUrl = _this2$props4.serverUrl,
                deleteUrl = _this2$props4.deleteUrl;
            var _this2$state3 = _this2.state,
                appCode = _this2$state3.appCode,
                files = _this2$state3.files;

            confirm({
                title: deleteTip,
                onOk: function onOk() {
                    var fileData = file.response.data[0];

                    var _ref2 = fileData || {},
                        billId = _ref2.billId,
                        fullPath = _ref2.fullPath,
                        pk_doc = _ref2.pk_doc;

                    var params = {
                        busiParamJson: JSON.stringify({
                            billId: billId,
                            fullPath: fullPath,
                            pk_doc: pk_doc
                        }),
                        sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
                    };
                    _ajax2.default.postJSONWithCookies(serverUrl + deleteUrl, params, function (result) {
                        if (result && result.success) {
                            _this.setState({
                                files: files.filter(function (file) {
                                    // 从文件列表中移除删除的文件
                                    return file.response.data[0].pk_doc !== pk_doc;
                                })
                            }, _this.changeValue);
                        }
                    });
                }
            });
        };

        _this2.state = {
            files: _this2.props.defaultFileList,
            serverUrl: _this2.props.serverUrl,
            appCode: _this2.props.appCode,
            billId: _this2.props.billId,
            disabled: _this2.props.disabled
        };
        return _this2;
    }

    _createClass(NccAttachUpload, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (!this.props.defaultFileList || !this.props.defaultFileList.length) {
                this.loadFiles();
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.appCode && nextProps.appCode !== this.props.appCode || nextProps.billId && nextProps.billId !== this.props.billId) {
                this.setState({ appCode: nextProps.appCode, billId: nextProps.billId }, this.loadFiles);
            }
            if (nextProps.disabled !== undefined && nextProps.disabled !== this.props.disabled) {
                this.setState({ disabled: nextProps.disabled });
            }
        }

        // 加载附件列表


        // 上传前的回调


        // 获取上传的参数


        // 上传文件


        // 预览文件(不支持在线预览，直接下载)


        // 删除附件

    }, {
        key: 'changeValue',


        // 回调外部form或者table的onChange事件，回传附件id
        value: function changeValue() {
            var files = this.state.files;

            var fileIds = [];
            files.map(function (file) {
                if (file.status === "done" && file.response) {
                    var fileData = file.response.data[0];
                    if (fileData && fileData.pk_doc) {
                        fileIds.push(fileData.pk_doc);
                    }
                }
            });
            if (this.props.onChange && typeof this.props.onChange === "function") {
                this.props.onChange(fileIds.join(","));
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var _props = this.props,
                serverUrl = _props.serverUrl,
                uploadUrl = _props.uploadUrl,
                accept = _props.accept,
                btnType = _props.btnType,
                buttonText = _props.buttonText;

            var action = serverUrl + uploadUrl;
            var _state = this.state,
                files = _state.files,
                disabled = _state.disabled;

            var view = null;
            if (disabled === true) {
                // 禁用状态
                var fileViews = [];
                files.map(function (fileItem) {
                    fileViews.push(_react2.default.createElement(
                        'div',
                        { className: 'ant-upload-list-item ant-upload-list-item-done' },
                        _react2.default.createElement(
                            'div',
                            { className: 'ant-upload-list-item-info' },
                            _react2.default.createElement('i', { className: 'anticon anticon-paper-clip' }),
                            _react2.default.createElement(
                                'a',
                                { title: fileItem.name, className: 'ant-upload-list-item-name',
                                    onClick: _this3.onPreview.bind(_this3, fileItem) },
                                fileItem.name
                            ),
                            _react2.default.createElement('i', { className: 'anticon' })
                        )
                    ));
                });
                view = _react2.default.createElement(
                    'div',
                    { className: 'ant-upload-list ant-upload-list-text' },
                    fileViews
                );
            } else {
                view = _react2.default.createElement(
                    _yylibUi.YYUpload,
                    _extends({}, this.props, { beforeUpload: this.beforeUpload, onChange: this.onChange,
                        data: this.getUploadParams, withCredentials: true, action: action, fileList: files,
                        onPreview: this.onPreview, onRemove: this.onRemove }),
                    accept ? _react2.default.createElement(
                        _yylibUi.YYTooltip,
                        { placement: 'top', title: '文件格式：' + accept },
                        _react2.default.createElement(
                            _yylibUi.YYButton,
                            { type: btnType, icon: 'upload' },
                            buttonText
                        )
                    ) : _react2.default.createElement(
                        _yylibUi.YYButton,
                        { type: btnType, icon: 'upload' },
                        buttonText
                    )
                );
            }
            return _react2.default.createElement(
                'div',
                { className: 'yyui-attach-upload' },
                view
            );
        }
    }]);

    return NccAttachUpload;
}(_react2.default.Component);

exports.default = NccAttachUpload;


NccAttachUpload.defaultProps = {
    disabled: false, // 是否禁用(不允许上传和删除)
    accept: '', // 接受上传的文件类型
    defaultFileList: [], // 默认上传的文件列表
    serverUrl: '', // 附件服务基准地址
    queryUrl: '/nccloud/platform/attachment/query.do', // 查询附件的服务地址
    uploadUrl: '/nccloud/platform/attachment/upload.do', // 上传文件的服务地址
    deleteUrl: '/nccloud/platform/attachment/delete.do', // 删除附件的服务地址
    downloadUrl: '/nccloud/platform/attachment/download.do', // 下载附件的服务地址
    showUploadList: true, // 是否显示已上传的文件列表
    btnType: '', // 按钮风格
    buttonText: "点击上传", // 按钮文本
    deleteTip: '', // 删除附件时提示内容
    multiple: false // 是否允许批量上传
};