'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _yylibUi = require('yylib-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 选择打印模板的对话框
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xg
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var NccPrintTplModal = function (_React$Component) {
    _inherits(NccPrintTplModal, _React$Component);

    function NccPrintTplModal(props) {
        _classCallCheck(this, NccPrintTplModal);

        var _this = _possibleConstructorReturn(this, (NccPrintTplModal.__proto__ || Object.getPrototypeOf(NccPrintTplModal)).call(this, props));

        _this.onOk = function () {
            var selectTplId = _this.state.selectTplId;

            if (!selectTplId) {
                return;
            }
            if (_this.props.onOk && typeof _this.props.onOk === 'function') {
                _this.props.onOk(selectTplId);
            }
        };

        _this.onCancel = function () {
            if (_this.props.onCancel && typeof _this.props.onCancel === 'function') {
                _this.props.onCancel();
            }
        };

        _this.onSelectChange = function (e) {
            _this.setState({ selectTplId: e.target.value });
        };

        _this.state = {
            visible: _this.props.visible,
            templates: _this.props.templates,
            selectTplId: _this.props.templates && _this.props.templates.length ? _this.props.templates[0]["m_ctemplateid"] : null
        };
        return _this;
    }

    _createClass(NccPrintTplModal, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps, nextContext) {
            if ("visible" in nextProps && nextProps.visible !== this.props.visible) {
                this.setState({ visible: nextProps.visible });
            }
            if ("templates" in nextProps && nextProps.templates !== this.props.templates) {
                var templates = nextProps.templates;
                this.setState({
                    templates: templates,
                    selectTplId: templates && templates.length ? templates[0]["m_ctemplateid"] : null
                });
            }
        }

        /**
         * 单选按钮切换事件
         */

    }, {
        key: 'getRadioOptions',
        value: function getRadioOptions() {
            var templates = this.state.templates;

            var options = [];
            var radioStyle = {
                display: 'block',
                height: '24px',
                lineHeight: '24px',
                marginLeft: '10px',
                marginTop: '5px',
                marginBottom: '5px',
                fontSize: '13px'
            };
            if (templates && templates.length) {
                templates.map(function (tpl) {
                    var tplId = tpl["m_ctemplateid"];
                    var tplName = tpl["m_vtemplatename"];
                    options.push(_react2.default.createElement(
                        _yylibUi.YYRadio,
                        { key: tplId, value: tplId, style: radioStyle },
                        tplName
                    ));
                });
            }
            return options;
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                visible = _state.visible,
                selectTplId = _state.selectTplId;

            return _react2.default.createElement(
                _yylibUi.YYModal,
                { width: '400', title: '\u6253\u5370\u6A21\u677F\u9009\u62E9', visible: visible, onOk: this.onOk,
                    onCancel: this.onCancel, maskClosable: false },
                _react2.default.createElement(
                    _yylibUi.YYRadioGroup,
                    { onChange: this.onSelectChange, value: selectTplId },
                    this.getRadioOptions()
                )
            );
        }
    }]);

    return NccPrintTplModal;
}(_react2.default.Component);

exports.default = NccPrintTplModal;


NccPrintTplModal.defaultProps = {
    visible: false, // 是否显示弹窗
    templates: [], // 打印模板数据
    onOk: function onOk() {}, // 点击确定按钮的回调
    onCancel: function onCancel() {} // 点击取消按钮的回调
};