'use strict';

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ajax = require('yylib-utils/ajax');
var _ = require('lodash');
var applicationName = '/icop-share-web';
var ROOT_DEFDOC = '/defdoc/manage/';

module.exports = {
    findDefDocListByCode: function findDefDocListByCode() {
        var serverUrl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window.EnvConfig.YYLIB_BASEHOST;
        var defdocTypeCode = arguments[1];
        var orgId = arguments[2];
        var dataparams = arguments[3];
        var callback = arguments[4];

        ajax.getJSON(serverUrl + applicationName + ROOT_DEFDOC + 'getbydefdoclistcode', {
            defdoclistCode: defdocTypeCode,
            orgId: orgId,
            condition: JSON.stringify(dataparams)
        }, function (data) {
            if (_.isFunction(callback)) {
                callback(data);
            }
        });
    },
    defdocByCode: function defdocByCode() {
        var serverUrl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window.EnvConfig.REF_BASE_URL;
        var refId = arguments[1];
        var callback = arguments[2];

        var params = {
            busiParamJson: JSON.stringify({
                pageInfo: { pageSize: 50, pageIndex: 0 },
                queryCondition: { pk_defdoclist: refId, icopRefType: 'icopgrid' }
            }),
            sysParamJson: {
                pagecs: _jsCookie2.default.get("cookiets")
            }
        };
        ajax.postJSONWithCookies(serverUrl + '/nccloud/uapbd/userdef/DefdocGridRef.do', params, function (data) {
            if (_.isFunction(callback)) {
                callback(data);
            }
        });
    }
};